# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/org/codehaus/jackson/%{name}/%{version}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with gcj_support

%if %with gcj_support
%define gcj_support 1
%else
%define gcj_support 0
%endif

%define section   free
%define base_name jackson

%global meadversion %{version}-redhat-2

Name:           codehaus-jackson
Version:        1.9.2
Release:        6_redhat_2%{?dist}.5
Epoch:          0
Summary:        Jackson is a Java-based JSON-processing 
Group:          Development/Libraries/Java
License:        Apache License v2.0 and LGPL v2.1
URL:            http://jackson.codehaus.org/
#Source0:        http://jackson.codehaus.org/1.3.5/jackson-src-1.3.5.tar.gz
Source0:        http://jackson.codehaus.org/1.9.2/jackson-src-1.9.2.tar.gz
#Source1: 	    %{name}-upload.sh
Source5:        %{name}-component-info.xml
Source6:        jackson-core-asl-1.9.2-vman.pom
Source7:        jackson-core-lgpl-1.9.2-vman.pom
Source8:        jackson-jaxrs-1.9.2-vman.pom
Source9:        jackson-mapper-asl-1.9.2-vman.pom
Source10:       jackson-mapper-lgpl-1.9.2-vman.pom
Source11:       jackson-mrbean-1.9.2-vman.pom
Source12:       jackson-smile-1.9.2-vman.pom
Source13:       jackson-xc-1.9.2-vman.pom
#Patch0:         codehaus-jackson-build_xml.patch
Patch0:         codehaus-jackson-1.9.2-build_xml.patch.rpmbuild
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  ant >= 0:1.6
BuildRequires:  ant-junit >= 0:1.6
BuildRequires:  ant-trax
BuildRequires:  jpackage-utils >= 0:1.7.2
BuildRequires:  junit4
BuildRequires:  jsr-311
BuildRequires:  maven-ant-tasks
BuildRequires:  cglib >= 2.1.0
BuildRequires:  jaf_1_1_api
BuildRequires:  maven-deploy-plugin
BuildRequires:  vman
BuildRequires:  jboss-parent
BuildRequires:  jboss-component-management

%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Jackson is a:
  * Streaming (reading, writing)
  * FAST (measured to be faster than any other Java json parser and data binder)
  * Powerful (full data binding for common JDK classes as well as any Java bean class, Collection, Map or Enum)
  * Zero-dependency (does not rely on other packages beyond JDK)
  * Open Source (LGPL or AL)
  * Fully conformant
JSON processor (JSON parser + JSON generator) written in Java. Beyond basic JSON reading/writing (parsing, generating), it also offers full node-based Tree Model, as well as full OJM (Object/Json Mapper) data binding functionality.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
Javadoc for %{name}.

%package core-asl
Summary:        core module from %{name} under asl license
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description core-asl
%{summary}.

%package core-lgpl
Summary:        core module from %{name} under lgpl license
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description core-lgpl
%{summary}.

%package mapper-asl
Summary:        mapper module from %{name} under asl license
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description mapper-asl
%{summary}.

%package mapper-lgpl
Summary:        mapper module from %{name} under lgpl license
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description mapper-lgpl
%{summary}.

%package jaxrs
Summary:        jaxrs module from %{name}
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description jaxrs
%{summary}.

%package xc
Summary:        xc module from %{name}
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description xc
%{summary}.

%package mrbean
Summary:        mrbean module from %{name}
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description mrbean
%{summary}.

%package smile
Summary:        smile module from %{name}
Group:          Development/Libraries/Java
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description smile
%{summary}.

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio

%endif

%prep
%setup -q -n jackson-src-%{version}
%patch0 -p1

%build
rm -rf lib/jaxrs/*
rm -rf lib/junit/*
#rm -rf lib/test/*
rm -rf lib/cobertura/*
rm -rf lib/perf/*
rm -rf lib/jaxb/*
#can not delete lib/ant/bndtask-0.2.0.jar due to the osgi task: net.luminis.build.plugin.bnd.BuildTask
rm -rf lib/ant/maven-ant-tasks-2.0.9.jar
export OPT_JAR_LIST="ant/ant-junit junit ant/ant-trax"
ln -s $(build-classpath maven-ant-tasks) lib/ant/maven-ant-tasks-2.0.9.jar
ln -s $(build-classpath jsr311-api) lib/jaxrs/jsr311-api-1.0.jar
ln -s $(build-classpath junit4) lib/junit/junit45.jar
#ln -s $(build-classpath cglib-nodep) lib/test/cglib-nodep-2.2.jar
ln -s $(build-classpath jaxb-api) lib/jaxb-api-2.0.jar
ln -s $(build-classpath activation) lib/activation.jar 
%{ant} all

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
install -d -m 755 %{buildroot}%{_javadir}/%{name}

install -pm 644 dist/jackson-core-asl-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -pm 644 dist/jackson-core-lgpl-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -pm 644 dist/jackson-jaxrs-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -pm 644 dist/jackson-mapper-asl-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -pm 644 dist/jackson-mapper-lgpl-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -pm 644 dist/jackson-xc-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -pm 644 dist/jackson-mrbean-%{version}.jar %{buildroot}%{_javadir}/%{name}
install -pm 644 dist/jackson-smile-%{version}.jar %{buildroot}%{_javadir}/%{name}

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

#javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr dist/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

# poms
%add_to_maven_depmap org.codehaus.jackson jackson-core-asl %{version} JPP/%{name} jackson-core-asl
%add_to_maven_depmap org.codehaus.jackson jackson-core-lgpl %{version} JPP/%{name} jackson-core-lgpl
%add_to_maven_depmap org.codehaus.jackson jackson-mapper-asl %{version} JPP/%{name} jackson-mapper-asl
%add_to_maven_depmap org.codehaus.jackson jackson-mapper-lgpl %{version} JPP/%{name} jackson-mapper-lgpl
%add_to_maven_depmap org.codehaus.jackson jackson-jaxrs %{version} JPP/%{name} jackson-jaxrs
%add_to_maven_depmap org.codehaus.jackson jackson-xc %{version} JPP/%{name} jackson-xc
%add_to_maven_depmap org.codehaus.jackson jackson-mrbean %{version} JPP/%{name} jackson-mrbean
%add_to_maven_depmap org.codehaus.jackson jackson-smile %{version} JPP/%{name} jackson-smile

install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
#modpom dist/jackson-core-asl-%{version}.pom
#modpom dist/jackson-core-lgpl-%{version}.pom
#modpom dist/jackson-mapper-asl-%{version}.pom
#modpom dist/jackson-mapper-lgpl-%{version}.pom
#modpom dist/jackson-jaxrs-%{version}.pom
#modpom dist/jackson-xc-%{version}.pom
install -pm 644 %{SOURCE6} %{buildroot}%{_datadir}/maven2/poms/JPP.jackson-core-asl.pom
install -pm 644 %{SOURCE7} %{buildroot}%{_datadir}/maven2/poms/JPP.jackson-core-lgpl.pom
install -pm 644 %{SOURCE9} %{buildroot}%{_datadir}/maven2/poms/JPP.jackson-mapper-asl.pom
install -pm 644 %{SOURCE10} %{buildroot}%{_datadir}/maven2/poms/JPP.jackson-mapper-lgpl.pom
install -pm 644 %{SOURCE8} %{buildroot}%{_datadir}/maven2/poms/JPP.jackson-jaxrs.pom
install -pm 644 %{SOURCE13} %{buildroot}%{_datadir}/maven2/poms/JPP.jackson-xc.pom

install -pm 644 %{SOURCE11} %{buildroot}%{_datadir}/maven2/poms/JPP.jackson-mrbean.pom
install -pm 644 %{SOURCE12} %{buildroot}%{_datadir}/maven2/poms/JPP.jackson-smile.pom

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %{with_repolib}
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
#for jackson-core-asl.jar
mvn-jpp deploy:deploy-file \
    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.jackson-core-asl.pom \
    -Dfile=%{buildroot}%{_javadir}/%{name}/jackson-core-asl.jar \
    -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
    -Dversion=%{meadversion} \

#for jackson-core-lgpl.jar
mvn-jpp deploy:deploy-file \
    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.jackson-core-lgpl.pom \
    -Dfile=%{buildroot}%{_javadir}/%{name}/jackson-core-lgpl.jar \
    -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
    -Dversion=%{meadversion}

#for jackson-mapper-asl.jar
mvn-jpp deploy:deploy-file \
    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.jackson-mapper-asl.pom \
    -Dfile=%{buildroot}%{_javadir}/%{name}/jackson-mapper-asl.jar \
    -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
    -Dversion=%{meadversion}

#for jackson-mapper-lgpl.jar
mvn-jpp deploy:deploy-file \
    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.jackson-mapper-lgpl.pom \
    -Dfile=%{buildroot}%{_javadir}/%{name}/jackson-mapper-lgpl.jar \
    -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
    -Dversion=%{meadversion}

#for jackson-jaxrs.jar
mvn-jpp deploy:deploy-file \
    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.jackson-jaxrs.pom \
    -Dfile=%{buildroot}%{_javadir}/%{name}/jackson-jaxrs.jar \
    -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
    -Dversion=%{meadversion}

#for jackson-xc.jar
mvn-jpp deploy:deploy-file \
    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.jackson-xc.pom \
    -Dfile=%{buildroot}%{_javadir}/%{name}/jackson-xc.jar \
    -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
    -Dversion=%{meadversion}

#for jackson-mrbean.jar
mvn-jpp deploy:deploy-file \
    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.jackson-mrbean.pom \
    -Dfile=%{buildroot}%{_javadir}/%{name}/jackson-mrbean.jar \
    -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
    -Dversion=%{meadversion}

#for jackson-smile.jar
mvn-jpp deploy:deploy-file \
    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP.jackson-smile.pom \
    -Dfile=%{buildroot}%{_javadir}/%{name}/jackson-smile.jar \
    -Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew/ \
    -Dversion=%{meadversion}

%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc README.txt

%{_datadir}/maven2/poms/JPP.jackson-core-asl.pom
%{_datadir}/maven2/poms/JPP.jackson-core-lgpl.pom
%{_datadir}/maven2/poms/JPP.jackson-mapper-asl.pom
%{_datadir}/maven2/poms/JPP.jackson-mapper-lgpl.pom
%{_datadir}/maven2/poms/JPP.jackson-jaxrs.pom
%{_datadir}/maven2/poms/JPP.jackson-mrbean.pom
%{_datadir}/maven2/poms/JPP.jackson-smile.pom
%{_mavendepmapfragdir}/%{name}
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.db
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.so
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files core-asl
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/jackson-core-asl.jar
%{_javadir}*/%{name}/jackson-core-asl-%{version}.jar
%{_datadir}/maven2/poms/JPP.jackson-core-asl.pom

%files core-lgpl
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/jackson-core-lgpl.jar
%{_javadir}*/%{name}/jackson-core-lgpl-%{version}.jar
%{_datadir}/maven2/poms/JPP.jackson-core-lgpl.pom

%files mapper-asl
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/jackson-mapper-asl.jar
%{_javadir}*/%{name}/jackson-mapper-asl-%{version}.jar
%{_datadir}/maven2/poms/JPP.jackson-mapper-asl.pom

%files mapper-lgpl
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/jackson-mapper-lgpl.jar
%{_javadir}*/%{name}/jackson-mapper-lgpl-%{version}.jar
%{_datadir}/maven2/poms/JPP.jackson-mapper-lgpl.pom

%files jaxrs
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/jackson-jaxrs.jar
%{_javadir}*/%{name}/jackson-jaxrs-%{version}.jar
%{_datadir}/maven2/poms/JPP.jackson-jaxrs.pom

%files xc
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/jackson-xc.jar
%{_javadir}*/%{name}/jackson-xc-%{version}.jar
%{_datadir}/maven2/poms/JPP.jackson-xc.pom

%files mrbean
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/jackson-mrbean.jar
%{_javadir}*/%{name}/jackson-mrbean-%{version}.jar
%{_datadir}/maven2/poms/JPP.jackson-mrbean.pom

%files smile
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/jackson-smile.jar
%{_javadir}*/%{name}/jackson-smile-%{version}.jar
%{_datadir}/maven2/poms/JPP.jackson-smile.pom

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
#%{repodir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Aug 16 2012 Paul Gier <pgier@redhat.com> - 0:1.9.2-5_redhat_2.5
- Update poms for eap 6.0.1

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.9.2-5_redhat_2.5
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.9.2-5_redhat_1.3
- Rebuild using cache signing

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.9.2-5_redhat_1.2
- Rebuild using cache signing

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.9.2-5_redhat_1.1
- Rebuild using cache signing

* Fri Jan 06 2012 Yong Yang <yyang@redhat.com> - 0:1.9.2-5_redhat_1
- Upgrade to 1.9.2
- Add vman poms as SOURCEs

* Mon Aug 29 2011 Yong Yang <yyang@redhat.com> - 0:1.6.3-4_redhat_1
- Call modpom script to run vman

* Mon Aug 29 2011 Yong Yang <yyang@redhat.com> - 0:1.6.3-3_redhat_1
- Run vman agaist the poms

* Mon Aug 29 2011 Yong Yang <yyang@redhat.com> - 0:1.6.3-2_redhat_1
- Build for werewolf

* Thu Jun 16 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.6.3-1
- Upgrade to 1.6.3

* Wed Feb 9 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.3.5-0.1.1.2
- Add %%update_maven_depmap in %%post and %%postun
- Change BR junit44 to junit4

* Fri Jan 14 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.3.5-0.1.1.1
- Rebuild

* Tue Nov 16 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.3.5-0.1.1
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew
- Add %%{_javadir}*/repository.jboss.com under %%files

* Tue May 18 2010 Yong Yang <yyang@redhat.com> - 0:1.3.5-0.1
- Upgrade to 1.3.5

* Tue May 04 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-2.1.1
- rebuilt

* Fri Apr 02 2010 Yong Yang <yyang@redhat.com> - 0:1.0.1-2.1
- Rebuild

* Thu Dec 17 2009 Yong Yang <yyang@redhat.com> - 0:1.0.1-2
- Combine multiple repolibs

* Fri Oct 30 2009 Yong Yang <yyang@redhat.com> - 0:1.0.1-1
- First release
